struct list_channel_s{
   unsigned short cmh,cml;              /* command register high, low word */
   struct list_channel_s  *next;};

struct channels_s{
   struct list_channel_s  *fcp;
   struct list_channel_s  *lcp;};


struct list_sequence_s{
   double                  scan_interval; /* will be translated to a scan interval time    */
   unsigned long           count;         /* number of scans that are te be read with this */
   struct list_sequence_s *next;};        /* scan interval time                            */

struct sequences_s{
   struct list_sequence_s *fsp;        /* pointer to first sequence */
   struct list_sequence_s *lsp;};      /* pointer to last sequence  */

void delete_sequences_s(struct sequences_s *sps){
   struct list_sequence_s *t,*tc;
   tc=(*sps).fsp;
   while(tc!=NULL){
      t=tc;
      tc=(*tc).next;
#ifdef MODULE
      kfree_s((void*)t,sizeof(struct list_sequence_s));
#else
      free(t);
#endif
      }
   (*sps).fsp=NULL;
   (*sps).lsp=NULL;}

int add_sequence(struct sequences_s *sps,double scan_interval,unsigned long count){      
   struct list_sequence_s *t;
#ifdef MODULE
   t=(struct list_sequence_s*)kmalloc(sizeof(struct list_sequence_s));
#else
   t=(struct list_sequence_s*)malloc(sizeof(struct list_sequence_s));
#endif
   if (t==NULL)
      return -ENOMEM;
   (*t).scan_interval=scan_interval;
   (*t).count=count;
   (*t).next=NULL;
   if ((*sps).lsp==NULL){
      (*sps).fsp=t;}
   else{
      (*(*sps).lsp).next=t;}
   (*sps).lsp=t;
   return 0;}

void delete_channels_s(struct channels_s *cps){
   struct list_channel_s *t,*c;
   c=(*cps).fcp;
   while(c!=NULL){
      t=c;
      c=(*c).next;
#ifdef MODULE
      kfree_s((void*)t,sizeof(struct list_channel_s));
#else
      free(t);
#endif
      }
   (*cps).fcp=NULL;
   (*cps).lcp=NULL;}

int add_channel(struct channels_s *cps,unsigned short cmh,unsigned short cml){
   struct list_channel_s *t;
#ifdef MODULE
   t=(struct list_channel_s*)kmalloc(sizeof(struct list_channel_s));
#else
   t=(struct list_channel_s*)malloc(sizeof(struct list_channel_s));
#endif
   if (t==NULL)
      return -ENOMEM;
   (*t).cmh=cmh;
   (*t).cml=cml;
   (*t).next=NULL;
   if ((*cps).lcp==NULL){
      (*cps).fcp=t;}
   else{
      (*(*cps).lcp).next=t;}
   (*cps).lcp=t;
   return 0;}

