/******************************************************************/
/*                                                                */
/*   mio64e3 setup.c - Perform  ..........                        */
/*                                                                */
/******************************************************************/

#include "tools.h"  



void main(){
   int fd,
       ioctl_error;
   struct list_sequence_s *t;
   time_t read_time,
          read_time_old,
          acquisition_start_time;
acquisition_start_time=time(&read_time);
read_time_old=acquisition_start_time;

  fd=open((DEVNAME), O_RDONLY);
  printf("# open: fd=%d, %s\n",fd,(DEVNAME));

  if (fd<=0) exit(0);


#include "channels.c"
#include "sequences.c"

  if(cps.fcp==NULL){
     printf("# No channel defined !\n");
     cleanup(fd);
     exit(0);}
  if(sps.fsp==NULL){
     printf("# No scan interval defined !\n");
     cleanup(fd);
     exit(0);}

  printf("# ioctl: %d, Set_Channel\n",ioctl(fd,Set_Channel,(unsigned long)(cps.fcp)));
  printf("# ioctl: %d, Set_Sequence\n",ioctl(fd,Set_Sequence,(unsigned long)(sps.fsp)));

  printf("# ioctl: %d, Get_Number_Of_Channels\n",ioctl(fd,Get_Number_Of_Channels));   
  printf("# ioctl: %d, Get_Number_Of_Scans\n",ioctl(fd,Get_Number_Of_Scans));  
  printf("# ioctl: %d, Get_Number_Of_Sequences\n",ioctl(fd,Get_Number_Of_Sequences));


  t=sps.fsp;
  printf("# sequence: scan_interval [s], number of scans []\n");
  do {
     printf("#                    %8.4f           %6d\n", (*t).scan_interval, (*t).count);
     t=(*t).next;
  } while(t!=NULL);
  printf("# chan 0,2-6,8-12,14-18,20-24,26-30,32-35 : single ended, +/- 5V\n");
  printf("# chan 1,7,13,19,25,31,36-56              : single ended, 0..10V\n");
  printf("# init time: %s", ctime(&acquisition_start_time));

  cleanup(fd);
}
